.\" This manpage has been automatically generated by docbook2man 
.\" from a DocBook document.  This tool can be found at:
.\" <http://shell.ipoline.com/~elmert/hacks/docbook2X/> 
.\" Please send any bug reports, improvements, comments, patches, 
.\" etc. to Steve Cheng <steve@ggi-project.org>.
.\" Patched 1999-08-03 by Thomas Lockhart <lockhart@alumni.caltech.edu>
.\" for the PostgreSQL RDBMS project (http://postgresql.org).
.TH "COMMIT" "l" "08 August 1999" "SQL - Language Statements" ""
.SH NAME
COMMIT \- Commits the current transaction
.SH SYNOPSIS
.sp
.nf
COMMIT [ WORK | TRANSACTION ]
  
.sp
.fi
.SS "INPUTS"
.PP
.TP
\fBWORK\fR
.TP
\fBTRANSACTION\fR
Optional keywords. They have no effect.
.PP
.SS "OUTPUTS"
.PP
.TP
\fBEND\fR
Message returned if the transaction is successfully committed.
.TP
\fBNOTICE EndTransactionBlock and not inprogress/abort state\fR
If there is no transaction in progress.
.PP
.SH "DESCRIPTION"
.PP
\fBCOMMIT\fR commits the current transaction. All
changes made by the transaction become visible to others
and are guaranteed to be durable if a crash occurs.
.SS "NOTES"
.PP
The keywords WORK and TRANSACTION are noise and can be omitted.
.PP
Use \fBrollback\fR(l)
to abort a transaction.
.SH "USAGE"
.PP
To make all changes permanent:
.sp
.nf
COMMIT WORK;
   
.sp
.fi
.SH "COMPATIBILITY"
.SS "SQL92"
.PP
Full compatibility.
