.\" This manpage has been automatically generated by docbook2man 
.\" from a DocBook document.  This tool can be found at:
.\" <http://shell.ipoline.com/~elmert/hacks/docbook2X/> 
.\" Please send any bug reports, improvements, comments, patches, 
.\" etc. to Steve Cheng <steve@ggi-project.org>.
.\" Patched 1999-08-03 by Thomas Lockhart <lockhart@alumni.caltech.edu>
.\" for the PostgreSQL RDBMS project (http://postgresql.org).
.TH "DROP_DATABASE" "l" "08 August 1999" "SQL - Language Statements" ""
.SH NAME
DROP DATABASE \- Destroys an existing database
.SH SYNOPSIS
.sp
.nf
DROP DATABASE \fIname\fR
  
.sp
.fi
.SS "INPUTS"
.PP
.TP
\fB\fIname\fB\fR
The name of an existing database to remove.
.PP
.SS "OUTPUTS"
.PP
.TP
\fBDESTROYDB\fR
This message is returned if the command is successful.
.TP
\fBWARN: destroydb: database "\fIname\fB" does not exist.\fR
This message occurs if the specified database does not exist.
.TP
\fBERROR: destroydb cannot be executed on an open database\fR
This message occurs if the specified database does not exist.
.PP
.SH "DESCRIPTION"
.PP
\fBDROP DATABASE\fR removes the catalog entries for an existing
database and deletes the directory containing the data.
It can only be executed by the database administrator
(See the \fBCREATE DATABASE\fR command for details).
.SS "NOTES"
.PP
This query cannot be executed while connected to the target
database. It is usually preferable to use
\fBdestroydb\fR(1)
instead.
.PP
Refer to
\fBcreatedb\fR(1) and
\fBcreate_database\fR(l)
for information on how to create a database.
.SH "COMPATIBILITY"
.SS "SQL92"
.PP
\fBDROP DATABASE\fR statement is a
Postgres language extension;
there is no such command in SQL92.
